/*
 * Խػ! - ΥեGladeˤäƤޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

static GnomeUIInfo file1_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("Exit"),
    NULL,
    (gpointer) on_exit_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo info_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("info"),
    NULL,
    (gpointer) on_info_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("depends"),
    NULL,
    (gpointer) on_depends_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("search"),
    NULL,
    (gpointer) on_search_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("status"),
    NULL,
    (gpointer) on_status_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo package_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("install"),
    NULL,
    (gpointer) on_install_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("remove"),
    NULL,
    (gpointer) on_remove_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("update package"),
    NULL,
    (gpointer) on_update_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("upgrade"),
    NULL,
    (gpointer) on_upgrade_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo update_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("update"),
    NULL,
    (gpointer) on_update_list_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo config_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("ipkg.conf configure"),
    NULL,
    (gpointer) on_source_select_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo help_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("about"),
    NULL,
    (gpointer) on_about_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo menubar1_uiinfo[] =
{
  GNOMEUIINFO_MENU_FILE_TREE (file1_menu_uiinfo),
  {
    GNOME_APP_UI_SUBTREE, N_("Info"),
    NULL,
    info_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_SUBTREE, N_("Package"),
    NULL,
    package_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_SUBTREE, N_("SystemUpdate"),
    NULL,
    update_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_SUBTREE, N_("Config"),
    NULL,
    config_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_SUBTREE, N_("Help"),
    NULL,
    help_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

GtkWidget*
create_WindowMain (void)
{
  GtkWidget *WindowMain;
  GtkWidget *dock1;
  GtkWidget *vbox1;
  GtkWidget *scrolledwindow1;
  GtkWidget *clist;
  GtkWidget *Lst_c1;
  GtkWidget *Lst_c2;
  GtkWidget *Lst_c3;
  GtkWidget *Lst_c4;
  GtkWidget *vbox5;
  GtkWidget *vbox6;
  GtkWidget *hbox1;
  GSList *ViewSelect_group = NULL;
  GtkWidget *radiobutton_all;
  GtkWidget *radiobutton_installed;
  GtkWidget *radiobutton_uninstalled;
  GtkWidget *scrolledwindow2;
  GtkWidget *Msg;
  GtkWidget *appbar1;

  WindowMain = gnome_app_new ("Sgipkg", _("Sgipkg"));
  gtk_object_set_data (GTK_OBJECT (WindowMain), "WindowMain", WindowMain);
  gtk_widget_set_usize (WindowMain, 190, 250);
  gtk_window_set_position (GTK_WINDOW (WindowMain), GTK_WIN_POS_CENTER);
  gtk_window_set_default_size (GTK_WINDOW (WindowMain), 190, 250);

  dock1 = GNOME_APP (WindowMain)->dock;
  gtk_widget_ref (dock1);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "dock1", dock1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dock1);

  gnome_app_create_menus (GNOME_APP (WindowMain), menubar1_uiinfo);

  gtk_widget_ref (menubar1_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "file1",
                            menubar1_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "exit",
                            file1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar1_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "info",
                            menubar1_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (info_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "info",
                            info_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (info_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "depends",
                            info_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (info_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "search",
                            info_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (info_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "status",
                            info_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar1_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "package",
                            menubar1_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (package_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "install",
                            package_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (package_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "remove",
                            package_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (package_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "update",
                            package_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (package_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "upgrade",
                            package_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar1_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "update",
                            menubar1_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (update_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "update_list",
                            update_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar1_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "config",
                            menubar1_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (config_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "source_select",
                            config_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar1_uiinfo[5].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "help",
                            menubar1_uiinfo[5].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (help_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "about",
                            help_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gnome_app_set_contents (GNOME_APP (WindowMain), vbox1);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow1, 60, 100);

  clist = gtk_clist_new (4);
  gtk_widget_ref (clist);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "clist", clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), clist);
  gtk_clist_set_column_width (GTK_CLIST (clist), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist), 1, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist), 2, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist), 3, 80);
  gtk_clist_column_titles_show (GTK_CLIST (clist));

  Lst_c1 = gtk_label_new (_("Package"));
  gtk_widget_ref (Lst_c1);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "Lst_c1", Lst_c1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Lst_c1);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 0, Lst_c1);
  gtk_widget_set_usize (Lst_c1, 50, -2);

  Lst_c2 = gtk_label_new (_("Version"));
  gtk_widget_ref (Lst_c2);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "Lst_c2", Lst_c2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Lst_c2);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 1, Lst_c2);
  gtk_widget_set_usize (Lst_c2, 20, -2);

  Lst_c3 = gtk_label_new (_("Section"));
  gtk_widget_ref (Lst_c3);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "Lst_c3", Lst_c3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Lst_c3);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 2, Lst_c3);
  gtk_widget_set_usize (Lst_c3, 20, -2);

  Lst_c4 = gtk_label_new (_("Size"));
  gtk_widget_ref (Lst_c4);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "Lst_c4", Lst_c4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Lst_c4);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 3, Lst_c4);
  gtk_widget_set_usize (Lst_c4, 20, -2);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_box_pack_start (GTK_BOX (vbox1), vbox5, TRUE, TRUE, 0);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox6);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "vbox6", vbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox6);
  gtk_box_pack_start (GTK_BOX (vbox5), vbox6, TRUE, TRUE, 0);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox6), hbox1, FALSE, TRUE, 0);
  gtk_widget_set_usize (hbox1, 190, 24);

  radiobutton_all = gtk_radio_button_new_with_label (ViewSelect_group, _("All"));
  ViewSelect_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_all));
  gtk_widget_ref (radiobutton_all);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "radiobutton_all", radiobutton_all,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_all);
  gtk_box_pack_start (GTK_BOX (hbox1), radiobutton_all, TRUE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton_all), TRUE);

  radiobutton_installed = gtk_radio_button_new_with_label (ViewSelect_group, _("Installed"));
  ViewSelect_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_installed));
  gtk_widget_ref (radiobutton_installed);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "radiobutton_installed", radiobutton_installed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_installed);
  gtk_box_pack_start (GTK_BOX (hbox1), radiobutton_installed, TRUE, FALSE, 0);

  radiobutton_uninstalled = gtk_radio_button_new_with_label (ViewSelect_group, _("Uninstalled"));
  ViewSelect_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_uninstalled));
  gtk_widget_ref (radiobutton_uninstalled);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "radiobutton_uninstalled", radiobutton_uninstalled,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_uninstalled);
  gtk_box_pack_start (GTK_BOX (hbox1), radiobutton_uninstalled, TRUE, FALSE, 0);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (vbox6), scrolledwindow2, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow2, -2, 100);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  Msg = gtk_text_new (NULL, NULL);
  gtk_widget_ref (Msg);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "Msg", Msg,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Msg);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), Msg);
  gtk_widget_set_usize (Msg, -2, 60);

  appbar1 = gnome_appbar_new (FALSE, FALSE, GNOME_PREFERENCES_NEVER);
  gtk_widget_ref (appbar1);
  gtk_object_set_data_full (GTK_OBJECT (WindowMain), "appbar1", appbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (appbar1);
  gnome_app_set_statusbar (GNOME_APP (WindowMain), appbar1);

  gtk_signal_connect (GTK_OBJECT (WindowMain), "destroy",
                      GTK_SIGNAL_FUNC (on_WindowMain_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (WindowMain), "destroy_event",
                      GTK_SIGNAL_FUNC (on_WindowMain_destroy_event),
                      NULL);
  gnome_app_install_menu_hints (GNOME_APP (WindowMain), menubar1_uiinfo);
  gtk_signal_connect (GTK_OBJECT (clist), "click_column",
                      GTK_SIGNAL_FUNC (on_clist_click_column),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (clist), "select_row",
                      GTK_SIGNAL_FUNC (on_clist_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Lst_c1), "button_press_event",
                      GTK_SIGNAL_FUNC (on_label_c1_button_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Lst_c2), "button_press_event",
                      GTK_SIGNAL_FUNC (on_Lst_c2_button_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Lst_c3), "button_press_event",
                      GTK_SIGNAL_FUNC (on_Lst_c3_button_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Lst_c4), "button_press_event",
                      GTK_SIGNAL_FUNC (on_Lst_c4_button_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_all), "pressed",
                      GTK_SIGNAL_FUNC (on_radiobutton_all_pressed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_installed), "pressed",
                      GTK_SIGNAL_FUNC (on_radiobutton_installed_pressed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_uninstalled), "pressed",
                      GTK_SIGNAL_FUNC (on_radiobutton_uninstalled_pressed),
                      NULL);

  return WindowMain;
}

GtkWidget*
create_WindowRemove (void)
{
  GtkWidget *WindowRemove;
  GtkWidget *dialog_vbox3;
  GtkWidget *vbox17;
  GtkWidget *RemoveCheck;
  GtkWidget *label12;
  GtkWidget *dialog_action_area3;
  GtkWidget *vbuttonbox1;
  GtkWidget *removeOK;
  GtkWidget *removeCancel;

  WindowRemove = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (WindowRemove), "WindowRemove", WindowRemove);
  gtk_widget_set_usize (WindowRemove, 170, 200);
  gtk_window_set_title (GTK_WINDOW (WindowRemove), _("Remove dialog"));
  GTK_WINDOW (WindowRemove)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (WindowRemove), GTK_WIN_POS_CENTER);
  gtk_window_set_default_size (GTK_WINDOW (WindowRemove), 170, 200);

  dialog_vbox3 = GTK_DIALOG (WindowRemove)->vbox;
  gtk_object_set_data (GTK_OBJECT (WindowRemove), "dialog_vbox3", dialog_vbox3);
  gtk_widget_show (dialog_vbox3);

  vbox17 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox17);
  gtk_object_set_data_full (GTK_OBJECT (WindowRemove), "vbox17", vbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox17);
  gtk_box_pack_start (GTK_BOX (dialog_vbox3), vbox17, FALSE, FALSE, 0);

  RemoveCheck = gtk_label_new ("");
  gtk_widget_ref (RemoveCheck);
  gtk_object_set_data_full (GTK_OBJECT (WindowRemove), "RemoveCheck", RemoveCheck,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RemoveCheck);
  gtk_box_pack_start (GTK_BOX (vbox17), RemoveCheck, FALSE, FALSE, 10);

  label12 = gtk_label_new (_("Do you want to remove?"));
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (WindowRemove), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label12);
  gtk_box_pack_start (GTK_BOX (vbox17), label12, FALSE, TRUE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label12), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label12), 0.5, 1);

  dialog_action_area3 = GTK_DIALOG (WindowRemove)->action_area;
  gtk_object_set_data (GTK_OBJECT (WindowRemove), "dialog_action_area3", dialog_action_area3);
  gtk_widget_show (dialog_action_area3);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area3), 10);

  vbuttonbox1 = gtk_vbutton_box_new ();
  gtk_widget_ref (vbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (WindowRemove), "vbuttonbox1", vbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbuttonbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area3), vbuttonbox1, TRUE, TRUE, 0);

  removeOK = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (removeOK);
  gtk_object_set_data_full (GTK_OBJECT (WindowRemove), "removeOK", removeOK,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (removeOK);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), removeOK);
  GTK_WIDGET_SET_FLAGS (removeOK, GTK_CAN_DEFAULT);

  removeCancel = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_ref (removeCancel);
  gtk_object_set_data_full (GTK_OBJECT (WindowRemove), "removeCancel", removeCancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (removeCancel);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), removeCancel);
  GTK_WIDGET_SET_FLAGS (removeCancel, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (removeOK), "clicked",
                      GTK_SIGNAL_FUNC (on_removeOK_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (removeCancel), "clicked",
                      GTK_SIGNAL_FUNC (on_removeCancel_clicked),
                      NULL);

  return WindowRemove;
}

GtkWidget*
create_WindowAbout (void)
{
  const gchar *authors[] = {
    NULL
  };
  GtkWidget *WindowAbout;

  WindowAbout = gnome_about_new ("Sgipkg", VERSION,
                        _("(C)2002 AXE,Inc."),
                        authors,
                        _("a GUI front end of ipkg command for Sikigami."),
                        NULL);
  gtk_object_set_data (GTK_OBJECT (WindowAbout), "WindowAbout", WindowAbout);
  gtk_window_set_modal (GTK_WINDOW (WindowAbout), TRUE);

  gtk_signal_connect (GTK_OBJECT (WindowAbout), "button_press_event",
                      GTK_SIGNAL_FUNC (on_WindowAbout_button_press_event),
                      NULL);

  return WindowAbout;
}

GtkWidget*
create_WindowConf (void)
{
  GtkWidget *WindowConf;
  GtkWidget *dialog_vbox5;
  GtkWidget *winconf_note;
  GtkWidget *vbox18;
  GtkWidget *scrolledwindow4;
  GtkWidget *winconf_clist_source;
  GtkWidget *label16;
  GtkWidget *label17;
  GtkWidget *table1;
  GtkWidget *winconf_source_name;
  GtkWidget *winconf_source_url;
  GtkWidget *label27;
  GtkWidget *label33;
  GtkWidget *hbuttonbox12;
  GtkWidget *winconf_source_add;
  GtkWidget *winconf_source_edit;
  GtkWidget *winconf_source_delete;
  GtkWidget *label13;
  GtkWidget *vbox19;
  GtkWidget *scrolledwindow5;
  GtkWidget *winconf_clist_dest;
  GtkWidget *label22;
  GtkWidget *label23;
  GtkWidget *table2;
  GtkWidget *label31;
  GtkWidget *label32;
  GtkWidget *winconf_dest_name;
  GtkWidget *winconf_dest_path;
  GtkWidget *hbuttonbox13;
  GtkWidget *winconf_dest_add;
  GtkWidget *winconf_dest_edit;
  GtkWidget *winconf_dest_delete;
  GtkWidget *label14;
  GtkWidget *vbox20;
  GtkWidget *scrolledwindow6;
  GtkWidget *winconf_clist_proxy;
  GtkWidget *label24;
  GtkWidget *label25;
  GtkWidget *table3;
  GtkWidget *label29;
  GtkWidget *label30;
  GtkWidget *winconf_proxy_option;
  GtkWidget *winconf_proxy_url;
  GtkWidget *hbuttonbox14;
  GtkWidget *winconf_proxy_add;
  GtkWidget *winconf_proxy_edit;
  GtkWidget *winconf_proxy_delete;
  GtkWidget *label21;
  GtkWidget *dialog_action_area5;
  GtkWidget *hbuttonbox11;
  GtkWidget *winconf_close;

  WindowConf = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (WindowConf), "WindowConf", WindowConf);
  gtk_widget_set_usize (WindowConf, 190, 250);
  gtk_window_set_title (GTK_WINDOW (WindowConf), _("Configure"));
  GTK_WINDOW (WindowConf)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_default_size (GTK_WINDOW (WindowConf), 190, 250);

  dialog_vbox5 = GTK_DIALOG (WindowConf)->vbox;
  gtk_object_set_data (GTK_OBJECT (WindowConf), "dialog_vbox5", dialog_vbox5);
  gtk_widget_show (dialog_vbox5);

  winconf_note = gtk_notebook_new ();
  gtk_widget_ref (winconf_note);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_note", winconf_note,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_note);
  gtk_box_pack_start (GTK_BOX (dialog_vbox5), winconf_note, TRUE, TRUE, 0);

  vbox18 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox18);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "vbox18", vbox18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox18);
  gtk_container_add (GTK_CONTAINER (winconf_note), vbox18);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_box_pack_start (GTK_BOX (vbox18), scrolledwindow4, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow4, 368, 120);

  winconf_clist_source = gtk_clist_new (2);
  gtk_widget_ref (winconf_clist_source);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_clist_source", winconf_clist_source,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_clist_source);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), winconf_clist_source);
  gtk_widget_set_usize (winconf_clist_source, 350, -2);
  gtk_clist_set_column_width (GTK_CLIST (winconf_clist_source), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (winconf_clist_source), 1, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (winconf_clist_source), GTK_SELECTION_BROWSE);
  gtk_clist_column_titles_show (GTK_CLIST (winconf_clist_source));

  label16 = gtk_label_new (_("src-name"));
  gtk_widget_ref (label16);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "label16", label16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label16);
  gtk_clist_set_column_widget (GTK_CLIST (winconf_clist_source), 0, label16);

  label17 = gtk_label_new (_("source-url"));
  gtk_widget_ref (label17);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "label17", label17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label17);
  gtk_clist_set_column_widget (GTK_CLIST (winconf_clist_source), 1, label17);
  gtk_label_set_line_wrap (GTK_LABEL (label17), TRUE);

  table1 = gtk_table_new (2, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (vbox18), table1, FALSE, TRUE, 0);
  gtk_widget_set_usize (table1, -2, 44);

  winconf_source_name = gtk_entry_new ();
  gtk_widget_ref (winconf_source_name);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_source_name", winconf_source_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_source_name);
  gtk_table_attach (GTK_TABLE (table1), winconf_source_name, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  winconf_source_url = gtk_entry_new ();
  gtk_widget_ref (winconf_source_url);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_source_url", winconf_source_url,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_source_url);
  gtk_table_attach (GTK_TABLE (table1), winconf_source_url, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label27 = gtk_label_new (_("source-url"));
  gtk_widget_ref (label27);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "label27", label27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label27);
  gtk_table_attach (GTK_TABLE (table1), label27, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label27), 0, 0.5);

  label33 = gtk_label_new (_("src-name"));
  gtk_widget_ref (label33);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "label33", label33,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label33);
  gtk_table_attach (GTK_TABLE (table1), label33, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label33), 0, 0.5);

  hbuttonbox12 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox12);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "hbuttonbox12", hbuttonbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox12);
  gtk_box_pack_start (GTK_BOX (vbox18), hbuttonbox12, FALSE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox12), GTK_BUTTONBOX_EDGE);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox12), 0);
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (hbuttonbox12), 85, 30);

  winconf_source_add = gtk_button_new_with_label (_("Add"));
  gtk_widget_ref (winconf_source_add);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_source_add", winconf_source_add,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_source_add);
  gtk_container_add (GTK_CONTAINER (hbuttonbox12), winconf_source_add);
  gtk_widget_set_usize (winconf_source_add, 0, -2);
  GTK_WIDGET_SET_FLAGS (winconf_source_add, GTK_CAN_DEFAULT);

  winconf_source_edit = gtk_button_new_with_label (_("Edit"));
  gtk_widget_ref (winconf_source_edit);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_source_edit", winconf_source_edit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_source_edit);
  gtk_container_add (GTK_CONTAINER (hbuttonbox12), winconf_source_edit);
  gtk_widget_set_usize (winconf_source_edit, 0, -2);
  GTK_WIDGET_SET_FLAGS (winconf_source_edit, GTK_CAN_DEFAULT);

  winconf_source_delete = gtk_button_new_with_label (_("Delete"));
  gtk_widget_ref (winconf_source_delete);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_source_delete", winconf_source_delete,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_source_delete);
  gtk_container_add (GTK_CONTAINER (hbuttonbox12), winconf_source_delete);
  gtk_widget_set_usize (winconf_source_delete, 0, -2);
  GTK_WIDGET_SET_FLAGS (winconf_source_delete, GTK_CAN_DEFAULT);

  label13 = gtk_label_new (_("Source"));
  gtk_widget_ref (label13);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "label13", label13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label13);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (winconf_note), gtk_notebook_get_nth_page (GTK_NOTEBOOK (winconf_note), 0), label13);

  vbox19 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox19);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "vbox19", vbox19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox19);
  gtk_container_add (GTK_CONTAINER (winconf_note), vbox19);

  scrolledwindow5 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow5);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "scrolledwindow5", scrolledwindow5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow5);
  gtk_box_pack_start (GTK_BOX (vbox19), scrolledwindow5, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow5, -2, 120);

  winconf_clist_dest = gtk_clist_new (2);
  gtk_widget_ref (winconf_clist_dest);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_clist_dest", winconf_clist_dest,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_clist_dest);
  gtk_container_add (GTK_CONTAINER (scrolledwindow5), winconf_clist_dest);
  gtk_clist_set_column_width (GTK_CLIST (winconf_clist_dest), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (winconf_clist_dest), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (winconf_clist_dest));

  label22 = gtk_label_new (_("dest-name"));
  gtk_widget_ref (label22);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "label22", label22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label22);
  gtk_clist_set_column_widget (GTK_CLIST (winconf_clist_dest), 0, label22);

  label23 = gtk_label_new (_("target-path"));
  gtk_widget_ref (label23);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "label23", label23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label23);
  gtk_clist_set_column_widget (GTK_CLIST (winconf_clist_dest), 1, label23);

  table2 = gtk_table_new (2, 2, FALSE);
  gtk_widget_ref (table2);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "table2", table2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table2);
  gtk_box_pack_start (GTK_BOX (vbox19), table2, FALSE, TRUE, 0);

  label31 = gtk_label_new (_("dest-name"));
  gtk_widget_ref (label31);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "label31", label31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label31);
  gtk_table_attach (GTK_TABLE (table2), label31, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label31), 0, 0.5);

  label32 = gtk_label_new (_("target-path"));
  gtk_widget_ref (label32);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "label32", label32,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label32);
  gtk_table_attach (GTK_TABLE (table2), label32, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label32), 0, 0.5);

  winconf_dest_name = gtk_entry_new ();
  gtk_widget_ref (winconf_dest_name);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_dest_name", winconf_dest_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_dest_name);
  gtk_table_attach (GTK_TABLE (table2), winconf_dest_name, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  winconf_dest_path = gtk_entry_new ();
  gtk_widget_ref (winconf_dest_path);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_dest_path", winconf_dest_path,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_dest_path);
  gtk_table_attach (GTK_TABLE (table2), winconf_dest_path, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  hbuttonbox13 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox13);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "hbuttonbox13", hbuttonbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox13);
  gtk_box_pack_start (GTK_BOX (vbox19), hbuttonbox13, FALSE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox13), GTK_BUTTONBOX_EDGE);

  winconf_dest_add = gtk_button_new_with_label (_("Add"));
  gtk_widget_ref (winconf_dest_add);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_dest_add", winconf_dest_add,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_dest_add);
  gtk_container_add (GTK_CONTAINER (hbuttonbox13), winconf_dest_add);
  GTK_WIDGET_SET_FLAGS (winconf_dest_add, GTK_CAN_DEFAULT);

  winconf_dest_edit = gtk_button_new_with_label (_("Edit"));
  gtk_widget_ref (winconf_dest_edit);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_dest_edit", winconf_dest_edit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_dest_edit);
  gtk_container_add (GTK_CONTAINER (hbuttonbox13), winconf_dest_edit);
  GTK_WIDGET_SET_FLAGS (winconf_dest_edit, GTK_CAN_DEFAULT);

  winconf_dest_delete = gtk_button_new_with_label (_("Delete"));
  gtk_widget_ref (winconf_dest_delete);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_dest_delete", winconf_dest_delete,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_dest_delete);
  gtk_container_add (GTK_CONTAINER (hbuttonbox13), winconf_dest_delete);
  GTK_WIDGET_SET_FLAGS (winconf_dest_delete, GTK_CAN_DEFAULT);

  label14 = gtk_label_new (_("Dest"));
  gtk_widget_ref (label14);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "label14", label14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label14);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (winconf_note), gtk_notebook_get_nth_page (GTK_NOTEBOOK (winconf_note), 1), label14);
  gtk_label_set_justify (GTK_LABEL (label14), GTK_JUSTIFY_LEFT);

  vbox20 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox20);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "vbox20", vbox20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox20);
  gtk_container_add (GTK_CONTAINER (winconf_note), vbox20);

  scrolledwindow6 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow6);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "scrolledwindow6", scrolledwindow6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow6);
  gtk_box_pack_start (GTK_BOX (vbox20), scrolledwindow6, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow6, -2, 120);

  winconf_clist_proxy = gtk_clist_new (2);
  gtk_widget_ref (winconf_clist_proxy);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_clist_proxy", winconf_clist_proxy,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_clist_proxy);
  gtk_container_add (GTK_CONTAINER (scrolledwindow6), winconf_clist_proxy);
  gtk_widget_set_usize (winconf_clist_proxy, 350, -2);
  gtk_clist_set_column_width (GTK_CLIST (winconf_clist_proxy), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (winconf_clist_proxy), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (winconf_clist_proxy));

  label24 = gtk_label_new (_("option"));
  gtk_widget_ref (label24);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "label24", label24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label24);
  gtk_clist_set_column_widget (GTK_CLIST (winconf_clist_proxy), 0, label24);

  label25 = gtk_label_new (_("proxy-url"));
  gtk_widget_ref (label25);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "label25", label25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label25);
  gtk_clist_set_column_widget (GTK_CLIST (winconf_clist_proxy), 1, label25);
  gtk_label_set_line_wrap (GTK_LABEL (label25), TRUE);

  table3 = gtk_table_new (2, 2, FALSE);
  gtk_widget_ref (table3);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "table3", table3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table3);
  gtk_box_pack_start (GTK_BOX (vbox20), table3, FALSE, TRUE, 0);

  label29 = gtk_label_new (_("option"));
  gtk_widget_ref (label29);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "label29", label29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label29);
  gtk_table_attach (GTK_TABLE (table3), label29, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label29), 0, 0.5);

  label30 = gtk_label_new (_("proxy-url"));
  gtk_widget_ref (label30);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "label30", label30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label30);
  gtk_table_attach (GTK_TABLE (table3), label30, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label30), 0, 0.5);

  winconf_proxy_option = gtk_entry_new ();
  gtk_widget_ref (winconf_proxy_option);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_proxy_option", winconf_proxy_option,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_proxy_option);
  gtk_table_attach (GTK_TABLE (table3), winconf_proxy_option, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  winconf_proxy_url = gtk_entry_new ();
  gtk_widget_ref (winconf_proxy_url);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_proxy_url", winconf_proxy_url,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_proxy_url);
  gtk_table_attach (GTK_TABLE (table3), winconf_proxy_url, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  hbuttonbox14 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox14);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "hbuttonbox14", hbuttonbox14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox14);
  gtk_box_pack_start (GTK_BOX (vbox20), hbuttonbox14, FALSE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox14), GTK_BUTTONBOX_EDGE);

  winconf_proxy_add = gtk_button_new_with_label (_("Add"));
  gtk_widget_ref (winconf_proxy_add);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_proxy_add", winconf_proxy_add,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_proxy_add);
  gtk_container_add (GTK_CONTAINER (hbuttonbox14), winconf_proxy_add);
  GTK_WIDGET_SET_FLAGS (winconf_proxy_add, GTK_CAN_DEFAULT);

  winconf_proxy_edit = gtk_button_new_with_label (_("Edit"));
  gtk_widget_ref (winconf_proxy_edit);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_proxy_edit", winconf_proxy_edit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_proxy_edit);
  gtk_container_add (GTK_CONTAINER (hbuttonbox14), winconf_proxy_edit);
  GTK_WIDGET_SET_FLAGS (winconf_proxy_edit, GTK_CAN_DEFAULT);

  winconf_proxy_delete = gtk_button_new_with_label (_("Delete"));
  gtk_widget_ref (winconf_proxy_delete);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_proxy_delete", winconf_proxy_delete,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_proxy_delete);
  gtk_container_add (GTK_CONTAINER (hbuttonbox14), winconf_proxy_delete);
  GTK_WIDGET_SET_FLAGS (winconf_proxy_delete, GTK_CAN_DEFAULT);

  label21 = gtk_label_new (_("Proxy"));
  gtk_widget_ref (label21);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "label21", label21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label21);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (winconf_note), gtk_notebook_get_nth_page (GTK_NOTEBOOK (winconf_note), 2), label21);

  dialog_action_area5 = GTK_DIALOG (WindowConf)->action_area;
  gtk_object_set_data (GTK_OBJECT (WindowConf), "dialog_action_area5", dialog_action_area5);
  gtk_widget_show (dialog_action_area5);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area5), 10);

  hbuttonbox11 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox11);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "hbuttonbox11", hbuttonbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox11);
  gtk_box_pack_start (GTK_BOX (dialog_action_area5), hbuttonbox11, TRUE, TRUE, 0);

  winconf_close = gtk_button_new_with_label (_("close"));
  gtk_widget_ref (winconf_close);
  gtk_object_set_data_full (GTK_OBJECT (WindowConf), "winconf_close", winconf_close,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_close);
  gtk_container_add (GTK_CONTAINER (hbuttonbox11), winconf_close);
  GTK_WIDGET_SET_FLAGS (winconf_close, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (winconf_note), "switch_page",
                      GTK_SIGNAL_FUNC (on_winconf_note_switch_page),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (winconf_clist_source), "select_row",
                      GTK_SIGNAL_FUNC (on_winconf_clist_source_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (winconf_source_add), "clicked",
                      GTK_SIGNAL_FUNC (on_winconf_source_add_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (winconf_source_edit), "clicked",
                      GTK_SIGNAL_FUNC (on_winconf_source_edit_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (winconf_source_delete), "clicked",
                      GTK_SIGNAL_FUNC (on_winconf_source_delete_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (winconf_clist_dest), "select_row",
                      GTK_SIGNAL_FUNC (on_winconf_clist_dest_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (winconf_dest_add), "clicked",
                      GTK_SIGNAL_FUNC (on_winconf_dest_add_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (winconf_dest_edit), "clicked",
                      GTK_SIGNAL_FUNC (on_winconf_dest_edit_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (winconf_dest_delete), "clicked",
                      GTK_SIGNAL_FUNC (on_winconf_dest_delete_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (winconf_clist_proxy), "select_row",
                      GTK_SIGNAL_FUNC (on_winconf_clist_proxy_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (winconf_proxy_add), "clicked",
                      GTK_SIGNAL_FUNC (on_winconf_proxy_add_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (winconf_proxy_edit), "clicked",
                      GTK_SIGNAL_FUNC (on_winconf_proxy_edit_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (winconf_proxy_delete), "clicked",
                      GTK_SIGNAL_FUNC (on_winconf_proxy_delete_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (winconf_close), "clicked",
                      GTK_SIGNAL_FUNC (on_winconf_close_clicked),
                      NULL);

  return WindowConf;
}

GtkWidget*
create_WindowConfRemoveCheck (void)
{
  GtkWidget *WindowConfRemoveCheck;
  GtkWidget *dialog_vbox6;
  GtkWidget *vbox21;
  GtkWidget *winconf_remove_env;
  GtkWidget *winconf_remove_data;
  GtkWidget *label37;
  GtkWidget *dialog_action_area6;
  GtkWidget *hbuttonbox15;
  GtkWidget *winconf_remove_check_ok;
  GtkWidget *winconf_remove_check_cancel;

  WindowConfRemoveCheck = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (WindowConfRemoveCheck), "WindowConfRemoveCheck", WindowConfRemoveCheck);
  gtk_widget_set_usize (WindowConfRemoveCheck, 190, 250);
  gtk_window_set_title (GTK_WINDOW (WindowConfRemoveCheck), _("Remove"));
  GTK_WINDOW (WindowConfRemoveCheck)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_default_size (GTK_WINDOW (WindowConfRemoveCheck), 190, 250);

  dialog_vbox6 = GTK_DIALOG (WindowConfRemoveCheck)->vbox;
  gtk_object_set_data (GTK_OBJECT (WindowConfRemoveCheck), "dialog_vbox6", dialog_vbox6);
  gtk_widget_show (dialog_vbox6);

  vbox21 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox21);
  gtk_object_set_data_full (GTK_OBJECT (WindowConfRemoveCheck), "vbox21", vbox21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox21);
  gtk_box_pack_start (GTK_BOX (dialog_vbox6), vbox21, TRUE, TRUE, 0);

  winconf_remove_env = gtk_label_new ("");
  gtk_widget_ref (winconf_remove_env);
  gtk_object_set_data_full (GTK_OBJECT (WindowConfRemoveCheck), "winconf_remove_env", winconf_remove_env,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_remove_env);
  gtk_box_pack_start (GTK_BOX (vbox21), winconf_remove_env, FALSE, FALSE, 5);
  gtk_label_set_justify (GTK_LABEL (winconf_remove_env), GTK_JUSTIFY_RIGHT);
  gtk_label_set_line_wrap (GTK_LABEL (winconf_remove_env), TRUE);

  winconf_remove_data = gtk_label_new ("");
  gtk_widget_ref (winconf_remove_data);
  gtk_object_set_data_full (GTK_OBJECT (WindowConfRemoveCheck), "winconf_remove_data", winconf_remove_data,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_remove_data);
  gtk_box_pack_start (GTK_BOX (vbox21), winconf_remove_data, FALSE, FALSE, 10);
  gtk_label_set_justify (GTK_LABEL (winconf_remove_data), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (winconf_remove_data), TRUE);

  label37 = gtk_label_new (_("Do you want to delete?"));
  gtk_widget_ref (label37);
  gtk_object_set_data_full (GTK_OBJECT (WindowConfRemoveCheck), "label37", label37,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label37);
  gtk_box_pack_start (GTK_BOX (vbox21), label37, FALSE, FALSE, 0);

  dialog_action_area6 = GTK_DIALOG (WindowConfRemoveCheck)->action_area;
  gtk_object_set_data (GTK_OBJECT (WindowConfRemoveCheck), "dialog_action_area6", dialog_action_area6);
  gtk_widget_show (dialog_action_area6);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area6), 10);

  hbuttonbox15 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox15);
  gtk_object_set_data_full (GTK_OBJECT (WindowConfRemoveCheck), "hbuttonbox15", hbuttonbox15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox15);
  gtk_box_pack_start (GTK_BOX (dialog_action_area6), hbuttonbox15, TRUE, TRUE, 0);

  winconf_remove_check_ok = gtk_button_new_with_label (_("Remove"));
  gtk_widget_ref (winconf_remove_check_ok);
  gtk_object_set_data_full (GTK_OBJECT (WindowConfRemoveCheck), "winconf_remove_check_ok", winconf_remove_check_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_remove_check_ok);
  gtk_container_add (GTK_CONTAINER (hbuttonbox15), winconf_remove_check_ok);
  GTK_WIDGET_SET_FLAGS (winconf_remove_check_ok, GTK_CAN_DEFAULT);

  winconf_remove_check_cancel = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_ref (winconf_remove_check_cancel);
  gtk_object_set_data_full (GTK_OBJECT (WindowConfRemoveCheck), "winconf_remove_check_cancel", winconf_remove_check_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (winconf_remove_check_cancel);
  gtk_container_add (GTK_CONTAINER (hbuttonbox15), winconf_remove_check_cancel);
  GTK_WIDGET_SET_FLAGS (winconf_remove_check_cancel, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (winconf_remove_check_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_winconf_remove_check_ok_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (winconf_remove_check_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_winconf_remove_check_cancel_clicked),
                      NULL);

  return WindowConfRemoveCheck;
}

