
#ifndef _SGIPKG_H
#define _SGIPKG_H


/** event$B%V%m%C%/(B **/
#define LOCKED

#define ON     0
#define OFF    1


#ifdef LOCKED
#define NOLOCK 0
#define LOCK   1
#endif


#define VIEW_ALL         0
#define VIEW_INSTALLED   1
#define VIEW_UNINSTALLED 2


#define STAT_NULL       -1
#define STAT_INSTALLED   0
#define STAT_UNINSTALLED 1

#define BUFF_SIZE      256
#define MBUFF_SIZE     128
#define SBUFF_SIZE      64

#define IPKG_BIN        "/usr/bin/ipkg"
#define IPKG_CONF_DIR   "/etc"


#define POST_NONE           0
#define POST_RESET_PKG_INFO 1

struct package_info
{
  char *package;
  char *version;
  char *section;
  char *size;
  int status;
};

struct input_add
{
  gint tag;
  GtkWidget *widget;
  FILE *fd;
};

#define MAX_PAKAGENAME_LENGTH 64

struct select_pkg
{
  int viewSelect;
  char pkg[MAX_PAKAGENAME_LENGTH];
  int status;
};


/* remark:WindowConf$B$N(Bnotebook$B%Z!<%8HV9f$H0lCW$5$;$k$3$H(B */
#define SOURCE   0
#define DEST     1
#define PROXY    2

struct ipkg_conf
{
  int row[3];
  GList *list[3];
  int select_page;
  gboolean conf;
};

struct conf_data
{
  char *env;
  char *data;
};


/*----------------
 * prototype(s)
 *----------------*/
void init_values (int);
void refresh (void);
void init_selected_package (void);
void set_selected_package (char *);
char *get_selected_package (void);
gboolean isSelected (void);
gboolean isInstalled (void);
void init_lock (void);
void set_lock (void);
void release_lock (void);
gboolean isLocked (void);
void set_view_select (int);
gboolean check_ipkg (void);
int get_view_select (void);
void clear_package_info (void);
void set_package_info (void);
void reset_status (int);
void set_package_status (char *);
void set_status (void);
int get_status (char *);
void reset_clist (void);
void clear_message (void);
void write_message (char *, GdkColor *);
void action_radiobutton (int);
void write_package_name (GtkWidget *);
void do_ipkg_nowait (char *, char *);
void do_ipkg_waiting (char *, char *, int);
void do_ipkg_and_write_message (char *);
void read_fd (gpointer, gint, GdkInputCondition);
void do_ipkg_and_waiting (char *, int);
void do_ipkg_info (char *);
void do_ipkg_update_list (void);
void do_ipkg_update (char *);
void do_ipkg_upgrade (void);
void do_ipkg_install (char *);
void do_ipkg_remove (char *);
void do_ipkg_list (void);
void do_ipkg_search (char *);
void do_ipkg_status (char *);
void do_ipkg_depends (char *);
char *get_ipkgconf_dir (void);
gboolean check_unique_conf_data (char *, char *, GList *);
gboolean check_conf_file (void);
void do_winconf_add (int);
void do_winconf_edit (int);
void do_winconf_delete (int);
void do_winconf_remove (void);
char *get_winconf_remove_envdata (int);
char *get_winconf_remove_env (void);
char *get_winconf_remove_data (void);
void write_winconf_remove_env_data (GtkWidget *);
void do_winconf_proxy_delete (void);
void clear_winconf_text_entry (int);
void set_winconf_text_entry (char *, char *);
void set_winconf_entry (int, int);
void init_clist_conf (char *, GList *);
void init_window_conf (void);
void init_confs (void);
gboolean read_conf (void);
void write_conf (FILE *, char *, GList *);
void write_ipkgconf (void);
#endif
